unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TFormMain = class(TForm)
    ButtonOpenDlg: TButton;
    procedure ButtonOpenDlgClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

uses
  Winapi.ActiveX,
  Winapi.ShlObj;

// https://docs.microsoft.com/en-us/windows/win32/learnwin32/example--the-open-dialog-box
procedure TFormMain.ButtonOpenDlgClick(Sender: TObject);
var
  hr: HResult;
  pFileOpen: IFileOpenDialog;
  pItem: IShellItem;
  pszFilePath: PChar;
begin
  // Create the FileOpenDialog object.
  hr := CoCreateInstance(CLSID_FileOpenDialog, nil, CLSCTX_ALL,
    IID_IFileOpenDialog, pFileOpen);

  if Succeeded(hr) then
  begin
    // Show the Open dialog box.
    hr := pFileOpen.Show(Handle);
    // Get the file name from the dialog box.
    if Succeeded(hr) then
    begin
      hr := pFileOpen.GetResult(pItem);
      if Succeeded(hr) then
      begin
        hr := pItem.GetDisplayName(SIGDN_FILESYSPATH, pszFilePath);

        // Display the file name to the user.
        if Succeeded(hr) then
        begin
          MessageBox(Handle, pszFilePath, 'File Path', MB_OK);
          CoTaskMemFree(pszFilePath);
        end;
        //pItem._Release();
      end;
    end;
    //pFileOpen._Release();
  end;
end;

end.
