unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.NetEncoding;

type
  TFormApi = class(TForm)
    btnStaticDll: TButton;
    btnEncode: TButton;
    EdtInput: TEdit;
    EdtPassword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnDecode: TButton;
    EdtOutput: TMemo;
    btnDynamicDll: TButton;
    procedure btnStaticDllClick(Sender: TObject);
    procedure btnEncodeClick(Sender: TObject);
    procedure btnDecodeClick(Sender: TObject);
    procedure btnDynamicDllClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormApi: TFormApi;

implementation

{$R *.dfm}

uses
  CNGCrypt.Core;

type
  TMyMessageBoxW = function (hWnd: HWND; lpText, lpCaption: LPCWSTR; uType: UINT): Integer; stdcall;


function AESEncryptString(const InputText, Password: string): string;
var
  Crypt: TCNGCrypt;
  OutputBytes: TBytes;
begin
  Crypt := TCNGCrypt.Create;
  try
    Crypt.Password := Password;
    Crypt.Encrypt(TEncoding.UTF8.GetBytes(InputText), OutputBytes);
    Result := TNetEncoding.Base64.EncodeBytesToString(OutputBytes);
  finally
    Crypt.Free;
  end;
end;

function AESDecryptString(const InputText, Password: string): string;
var
  Crypt: TCNGCrypt;
  OutputBytes: TBytes;
begin
  Crypt := TCNGCrypt.Create;
  try
    Crypt.Password := Password;
    Crypt.Decrypt(TNetEncoding.Base64.DecodeStringToBytes(InputText), OutputBytes);
    Result := TEncoding.UTF8.GetString(OutputBytes);
  finally
    Crypt.Free;
  end;
end;

procedure TFormApi.btnStaticDllClick(Sender: TObject);
begin
  MessageBox(Handle, PChar('Hello, world!'), 'Caption', MB_YESNOCANCEL);
end;

procedure TFormApi.btnDynamicDllClick(Sender: TObject);
var
  hDllInst: THandle;
  MyMessageBox: TMyMessageBoxW;
begin
  // WindowFromPhysicalPoint();

  hDllInst := SafeLoadLibrary('user32.dll');
  if hDllInst <> 0 then
  try
    MyMessageBox := TMyMessageBoxW(GetProcAddress(hDllInst, 'MessageBoxW'));

    MyMessageBox(0, 'Dynamic loading', 'Messaggio di prova', MB_ICONINFORMATION);

  finally
    FreeLibrary(hDllInst);
  end;
end;

procedure TFormApi.btnEncodeClick(Sender: TObject);
begin
  EdtOutput.Text := AESEncryptString(EdtInput.Text, EdtPassword.Text);
end;

procedure TFormApi.btnDecodeClick(Sender: TObject);
begin
  EdtInput.Text := AESDecryptString(EdtOutput.Text, EdtPassword.Text);
end;

end.
